﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.OrganizationProcesss
@{
    ViewData["Title"] = "Index";
}
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}

<script src="~/Script/ApplicationManagement/OrganizationProcess.js"></script>
<script src="~/Script/Master/Layout.js"></script>

<script>
    $(document).ready(function () {
        if ($("#Id").val() > 0) {
            $(".titile_heading h1").html("Add Process");
            $("#dvForm").show();
            $(".assign_panel").hide();
            $(".titile_heading").show();
            if ($("#IsType").val() == 1) {
                fn_HideChildOrg();
                $("#Parent").attr('checked', 'checked');
            } else {
                fn_ShowChildOrg();
                $("#Child").attr('checked', 'checked');
            }
        } else {
            $(".titile_heading h1").html("Process List");
            $("#dvForm").hide();
            $(".assign_panel").show();
            $(".titile_heading").show();
            $("#hdnChildOrg").hide();
        }
    });
</script>
<style>
    .table thead tr th input[type="button"] {
        border: 1px solid #c3bbbbee;
        padding: 2px 10px;
        color: #61c1c1;
        background-color: #ffff;
        border-radius: 5px;
    }
</style>
<section>
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Client List</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="" id="dvForm">
                        <form id="form" method="post" asp-action="SubmitFunctionProcess" asp-controller="OrganizationProcess"
                              data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading..."
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/OrganizationProcess/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.Id)
                            @Html.HiddenFor(m => m.xmlProcess)
                            @Html.HiddenFor(m => m.IsType)
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="radio-inline">
                                            <input type="radio" name="ISOTypeId" id="Parent" value="1" onclick="fn_HideChildOrg()" checked>Parent Organization
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="ISOTypeId" id="Child" value="2" onclick="fn_ShowChildOrg()">Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="row pt-2">
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label class="required">Parent Organization</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.ParentOrgId, Model.DdlParentOrg, "--Select--", new { @class = "form-control m_no", required = "required", @onchange = "fn_BindChildOrg(this),fn_BindOrganizationParentFunction(this);" })
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12" id="hdnChildOrg">
                                    <label>Child Organization</label>
                                    <div class="select_box m_bottom">
                                        @if (Model.Id > 0)
                                        {
                                            @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlChildOrg, "--Select--", new { @class = "form-control m_no", @onchange = "fn_BindOrganizationChildFunction(this);" })
                                        }
                                        else
                                        {
                                            @Html.DropDownListFor(m => m.ChildOrgId, Enumerable.Empty<SelectListItem>(), "--Select--", new { @class = "form-control m_no", @onchange = "fn_BindOrganizationChildFunction(this);" })
                                        }
                                    </div>
                                </div>
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label class="required">Function</label>
                                    <div class="select_box m_bottom">
                                        @if (Model.Id > 0)
                                        {
                                            @Html.DropDownListFor(m => m.FunctionId, Model.DdlFunction, "--Select--", new { @class = "form-control m_no", required = "required", onchange = "BindConsultantDdl()" })
                                        }
                                        else
                                        {
                                            @Html.DropDownListFor(m => m.FunctionId, Enumerable.Empty<SelectListItem>(), "--Select--", new { @class = "form-control m_no", required = "required", onchange = "BindConsultantDdl()" })
                                        }
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-6 col-xs-12">
                                    <div class="table_control">
                                        <table class="table" id="tblProcess">
                                            <thead>
                                                <tr>
                                                    <th>S.No.</th>
                                                    <th hidden>ID</th>
                                                    <th>Process</th>
                                                    <th>Process Owner</th>
                                                    <th>Description</th>
                                                    <th>Consultant</th>
                                                    <th>Action<input type="button" value="Add" class="pull-right" onclick="fn_AddNewRow();"> </th>
                                                </tr>
                                            </thead>
                                            <tbody>

                                                @{int no = 0, i = 0;}
                                                @if (Model.Id > 0)
                                                {
                                                    if (Model.FunctionProcessMapList.Count > 0)
                                                    {
                                                        foreach (var item in Model.FunctionProcessMapList)
                                                        {
                                                            <tr>
                                                                <td>@(++no)</td>
                                                                <td hidden><input type="text" class="form-control" value="@item.Id" /></td>
                                                                <td><input type="text" class="form-control" value="@item.ProcessIdentified" /></td>
                                                                <td><input type="text" class="form-control" value="@item.FunctionalOwner" /></td>
                                                                <td><input type="text" class="form-control" value="@item.Description" /></td>
                                                                <td>
                                                                    <select class="form-control m_no consultant@(i++)">
                                                                        <option value="0">Select Consultant</option>
                                                                        @foreach (var con in Model.ConsultantList)
                                                                        {
                                                                            @if (item.ConsultantId == con.ConsultantId)
                                                                            {
                                                                                <option value="@con.ConsultantId" selected>@con.ConsultantName</option>
                                                                            }
                                                                            else
                                                                            {
                                                                                <option value="@con.ConsultantId">@con.ConsultantName</option>
                                                                            }
                                                                        }
                                                                    </select>
                                                                </td>
                                                                <td><a class="delete_btn" onclick="removeRow($(this))"></a></td>
                                                            </tr>
                                                        }
                                                    }
                                                }
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <div class="row pt-3">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="back_btn">
                                        <div class="back_btn_in">
                                            <input type="button" id="btnBack" name="Submit" value="Back" onclick="hideForm()">
                                        </div>
                                    </div>
                                    <div class="submitbtn">
                                        <input type="submit" value="Submit" onclick="fn_SaveProcessxml();">
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>

                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="addbtn">
                            <div class="add_litigation">
                                <span>+</span>
                                <input type="button" onclick="AddButton()" value="Add Process">
                            </div>
                        </div>
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Parent Organization Name</th>
                                                <th>Child Organization Name</th>
                                                <th>Function Name</th>
                                                <th>Process Name</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{
                                                int sn = 0;
                                                var list = Model.FunctionProcessList;
                                                foreach (var item in list.Select(x => new { x.ParentOrgName, x.ChildOrgName, x.FunctionId, x.FunctionName, x.Id }).Distinct())
                                                {
                                                    <tr>
                                                        <td>@(++sn)</td>
                                                        <td>@item.ParentOrgName</td>
                                                        <td>@item.ChildOrgName</td>
                                                        <td>@item.FunctionName</td>
                                                        <td>
                                                            @{
                                                                int count = 0;
                                                                var processes = list.Where(x => x.FunctionId == item.FunctionId).ToList();
                                                                foreach (var proc in processes)
                                                                {
                                                                    count++;
                                                                    @(proc.ProcessIdentified += count==processes.Count()? "":", ")
                                                                }
                                                            }
                                                        </td>
                                                        <td>
                                                            <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-ID="@item.Id" asp-controller="OrganizationProcess" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                            @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                            @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                        </td>
                                                    </tr>
                                                }
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

    </div>
</section>
